<!-- Copyright (c) Vincent Dardel, <vindarez@mailz.org>,  Abelujo Developers-->
<!-- See the COPYRIGHT file at the top-level directory of this distribution-->
<!-- Abelujo is free software: you can redistribute it and/or modify-->
<!-- it under the terms of the GNU Affero General Public License as published by-->
<!-- the Free Software Foundation, either version 3 of the License, or-->
<!-- (at your option) any later version.-->
<!-- Abelujo is distributed in the hope that it will be useful,-->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of-->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the-->
<!-- GNU Affero General Public License for more details.-->
<!-- You should have received a copy of the GNU Affero General Public License-->
<!-- along with Abelujo.  If not, see <http://www.gnu.org/licenses/>.-->
{% extends "base.html" %}

<!-- Using abelujo-js.js -->
<!-- info: html generated from a .jade -->

{% block content %}
{% load bootstrap3 %}
{% bootstrap_css %}
{% bootstrap_javascript %}
{% load i18n %}
{% load currencyfilter %}

<span>
  <a href="{% url 'history_sells_day' previous_day_fmt %}">
    <button class="btn btn-default btn-sm" style="margin-bottom: 5px">&larr; {{ previous_day | date:'l' }} </button>
  </a>

  <span style="margin: 3px">
    {{ day | date:'l d N Y' | capfirst }}
  </span>
</span>

{% if  next_day_fmt %}
<span>
  <a hx-boost="true"
      href="{% url 'history_sells_day' next_day_fmt %}">
    <button class="btn btn-default btn-sm"> {{ next_day | date:'l' }} &rarr; </button>
  </a>
</span>
{% endif %}

<input type="date" id="history-date-picker" name="history-date-picker"
    style="margin-left: 1em"
    value="{{ day.year }}-{{ day.month }}-{{ day.day }}"
    min="{{ HISTORY_MIN_DATE.year }}-{{ HISTORY_MIN_DATE | date:'m' }}-{{ HISTORY_MIN_DATE | date:'d' }}" max="{{ now.year }}-{{ now.month }}-{{ now.day}}"
>

{% get_current_language as LANGUAGE_CODE %}

<button class="btn btn-default btn-sm" onclick="window.location.pathname = '/{{ LANGUAGE_CODE }}/history/sells/day/' + document.getElementById('history-date-picker').value"> &#10004; </button>


<a style="padding-left: 1em; text-decoration: underline;" href="/{{ LANGUAGE_CODE }}/history/sells/month/{{ day.year }}-{{ day.month }}">
  {{ day | date:'F' }} {{ day.year }}
</a>

&nbsp;&bull;

<a style="text-decoration: underline;" href="/{{ LANGUAGE_CODE }}/history/sells/month/">
  {{ now | date:'F' }} {{ now.year }}
</a>

<!-- bullet point -->
&nbsp;&bull;

<a hx-boost="true" style="text-decoration: underline;" href="/{{ LANGUAGE_CODE }}/history/today/">
  {% trans "today" %}
  {% if day.year = now.year and day.month = now.month and day.day = now.day %}
  <!-- Check mark: -->
  <span>
    &#10004;
  </span>
  {% endif %}
</a>

<div id="alerts">
  <div id="success" role="alert" hidden="hidden" class="alert alert-success"></div>
  <div id="warnings"></div>
</div>

<div class="row">
  <div class="col-lg-10">
    <ul class="nav nav-tabs">
      <li role="presentation" class="active"><a>{% trans "Sells" %}</a>
      </li>
      <li role="presentation"><a href="{% url 'history_entries_day' day|date:'Y-m-d'  %}">{% trans "Entries" %}</a>
      </li>
    </ul>
  </div>
</div>

<h3>{{ day | date:'l d F Y' | title }}</h3>

<div  class="row">
  <!-- div plus gros panier (?)-->
  <div class="col-md-4 panel panel-info">
    <div class="panel-heading">{% trans "Cash register" %}</div>
    <div class="panel-body">
      <h4> {{ sells_data.total_price_sold_fmt }} </h4>

      <div class="col-md-12" style="padding-left: 0; margin-left: 0">

        <div class="col-md-6">
          {% for total_per_payment in total_per_payment_items %}
          <div>
            <i class="glyphicon glyphicon-hand-right"></i>
            {{ total_per_payment.0 }}: {{ total_per_payment.1 }}
          </div>
          {% endfor %}
        </div>

        <div class="col-md-6">
          <div>
            <span class="badge badge-info"> {% trans "Books" %} </span>
            <span> {{ sells_data.total_price_sold_books_fmt }} </span>
          </div>
          <div>
            <span class="badge badge-info"> {% trans "Other products" %} </span>
            <span> {{ sells_data.total_price_sold_not_books_fmt }} </span>
          </div>
          {% for it in data_grouped_sells %}
          {% if it.0 != 'book' %}
          <div>
            <!-- Does the currency filter support Senegal? -->
            {{ it.0 }} : {{ it.1.total_sold | currency }}
          </div>
          {% endif %}
          {% endfor %}
        </div>

      </div>
    </div>
  </div>

  <div class="col-md-2 panel panel-info">
    <div class="panel-heading">{% trans "Articles sold" %}</div>
    <div class="panel-body">
      <h4>
        <span>{{ sells_data.nb_cards_sold }}</span>
        {% if  sells_data.nb_cards_returned %}<span>&nbsp; {% trans "Articles returned" %}: {{ sells_data.nb_cards_returned }}</span>{% endif %}
      </h4>

      <span> {% trans "books" %} </span>
      <span> {{ sells_data.nb_books_sold }} </span>

      {% for it in data_grouped_sells %}
      {% if it.0 != 'book' %}
      <div>
        <span> {{ it.0 }} </span>
        <span> {{ it.1.total_sells }} </span>
      </div>
      {% endif %}
      {% endfor %}
    </div>
  </div>

  <div class="col-md-2 panel panel-info">
    <div class="panel-heading">{% trans "Cash register movements" %}</div>
    <div class="panel-body">
      <h4>{{ sells_data.nb_sells }} </h4>

      {% trans "books" %} {{ sells_data.nb_books_sells }}

      {% for it in data_grouped_sells %}
      {% if it.0 != 'book' %}
      <div>
        {{ it.0 }} {{ it.1.nb_sells }}
      </div>
      {% endif %}
      {% endfor %}

    </div>
  </div>

  <div class="col-md-2 panel panel-info">
    <div class="panel-heading">{% trans "Average basket" %}</div>
    <div class="panel-body">
      <h4>
        {{ sells_data.sell_mean_fmt }}
      </h4>
      <span> {% trans "books" %} </span>
      <span> {{ sells_data.books_sell_mean | currency }} </span>

      {% for it in data_grouped_sells %}
      {% if it.0 != 'book' %}
      <div>
        <span> {{ it.0 }} </span>
        <span> {{ it.1.sell_mean | currency }} </span>
      </div>
      {% endif %}
      {% endfor %}

    </div>
  </div>

  <div class="col-md-2 panel panel-info">
    <div class="panel-heading">{% trans "Best sells" %}</div>
    <div class="panel-body">
      <button type="button" class="btn btn-default" data-toggle="modal" data-target="#myModal">
        {% trans "Best sells" %}
      </button>
    </div>
  </div>
</div>



<table class="table table-condensed" x-data="{ open: false }">
  <!-- better: iterate over sells, and iterate over soldcards.-->
  <thead>
    <th>{% trans "Transaction" %}</th>
    <th>
      <button @click="open = ! open" title="{% trans "Hide and show covers (d)" %}" class="btn btn-default btn-sm"><i class="glyphicon glyphicon-th-list"></i>
    </th>
    <th>{% trans "Title" %}</th>
    <th>{% trans "Publisher" %}</th>
    <th>{% trans "Price sold" %} </th>
    <th class="text-right">{% trans "Total" %} </th>
    <th>{% trans "Payment" %}</th>
    <th>{% trans "Client" %}</th>
    <th>
      <!-- bill button -->
    </th>
    <th>
      <!-- quantity in stock -->
    </th>
    <th>
      <!-- command button -->
    </th>
    <th>
      <!-- delete sell button -->
    </th>
  </thead>

  {% for it,bg_color,payment,new_sell,sell_id in data %}
  {% with card=it.card object=it.card %}
  <tr style="background-color: {{ bg_color }}" id="sell{{ sell_id }}">
    <td>
      {% if new_sell %}
      {{ sell_id }}
      &bull;
      {{ it.created | date:'H:i' }} 
      {% endif %}

    </td>

    <td>
      <div class="col-md-6" x-show="open" x-cloak>

        <!-- Click to enlarge image. -->
        <a data-toggle="modal"
            data-target="#enlargeImageModal{{ card.id }}"
	    title="{% trans 'Enlarge image' %}">
          <img src="{{ card.img }}" class="myImg mouse-pointer"/>
        </a>
      </div>

      <!-- enlargeImageModal ci-dessous: -->
      <div id="enlargeImageModal{{ card.id }}" class="modal">
        {% include "search/modale_enlarge_image.html" %}
      </div>


    </td>

    <td>&nbsp;<a href="{{ it.card.get_absolute_url }}">{{ it.card.title }}</a>

      {% if it.card.card_type.name and it.card.card_type.name != 'book' %}
      {% if it.card.card_type.name != 'Livre' %}
        ({{ it.card.card_type }})
      {% endif %}
      {% endif %}

    </td>
    <td>{{ it.card.pubs_repr }}</td>
    <td class="text-right">{{ it.price_sold | floatformat:2 }}
      {% if  it.quantity != 1 %}
      <span {% if it.quantity < 0 %} style="background-color: yellow" {% endif %}>
        &nbsp;x {{ it.quantity }}
      </span>
      {% endif %}
    </td>
    <td class="text-right">{% if  new_sell %}<span>{{ it.sell.total_price_sold | floatformat:2 }}</span>{% endif %}
    </td>
    <td>
      {{ payment }}
    </td>
    <td>
      {% if new_sell %}
      {% if  it.sell.client %}
      <a href="/{{ LANGUAGE_CODE }}/databasesearch/client/{{ it.sell.client.pk }}/" title="{{ it.sell.client.name }}, {{ it.sell.client.firstname }}" target="_blank">{{ it.sell.client.name | truncatechars:9 }}</a>
      {% endif %}

      {% if it.sell.bon_de_commande %}
      <div title='{% trans "Bon de commande" %}'>
        <i class="glyphicon glyphicon-paperclip"> </i>
        {{ it.sell.bon_de_commande }}
      </div>
      {% endif %}
      {% endif %}
    </td>

    <td>
      {% if new_sell %}
      <button type="button" class="btn btn-default btn-sm"
          onclick="sellBill({{ sell_id }})">
        <i class="glyphicon glyphicon-file"> </i>
      </button>
      {% endif %}
    </td>

    <td>
      <span title="{% trans 'En stock' %}"> {{ it.card.quantity }} </span>
    </td>

    <td>

      <span class="btn-group", style="margin-left: 1em" data-comment="copied from card_show">
        {% if user.is_staff %}
        <a class="btn btn-warning btn-sm" title='{% trans "Remember to command this card. Add it to the list for later." %}' onclick="card_command({{ it.card.pk }})">
          {% else %}
          <!-- Same, no onclick -->
          <a class="btn btn-warning" title='{% trans "Remember to command this card. Add it to the list for later." %}' disabled>
            {% endif %}
            <i class="glyphicon glyphicon-shopping-cart"> </i>
            <span> x
              <span id="nb_to_command_{{ it.card.pk }}"> {{ it.card.quantity_to_command }}
              </span>
            </span>
          </a>
      </span>
    </td>

    <td>
      {% if  new_sell %}
      <div title="{% trans "Cancel a sell" %}. On ne peut pas annuler une vente du mois dernier."
          {% if user.is_staff and now.year == day.year and now.month == day.month %}
          class="mouse-pointer glyphicon glyphicon-remove"
          onclick="sellUndo({{ sell_id }})"
          {% else %}
          class="glyphicon glyphicon-ban-circle"
          disabled
          {% endif %}
      ></div>
      {% endif %}
    </td>
  </tr>
  {% endwith %}
  {% endfor %}
</table>

<!-- The Modal -->
<div class="modal" id="myModal">
  <div class="modal-dialog">
    <div class="modal-content">

      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title"> {% trans "Best sells" %} </h4>
        <button type="button" class="close" data-dismiss="modal">&times;</button>
      </div>

      <!-- Modal body -->
      <div class="modal-body">
        <h4>  </h4>
        <h5> {% trans "Books" %} </h5>
        <table class="table">
          {% for it in best_sells.book %}
          <tr>
            <td>
              <a href="{{it.0.get_absolute_url}}")> {{ it.0.title }} </a>
            </td>
            <td> {{ it.1 }} </td>
          </tr>
          {% endfor %}
        </table>

        {% for other in best_sells.items %}
        {% if other.0 != 'book' %}
        {% if other.1 %}
        <h5> {{ other.0 }} </h5>
        <table class="table">
          {% for it in other.1 %}
          <tr>
            <td>
              <a href="{{it.0.get_absolute_url}}")> {{ it.0.title }} </a>
            </td>
            <td> {{ it.1 }} </td>
          </tr>
          {% endfor %}
          {% endif %}
          {% endif %}
          {% endfor %}
        </table>
      </div>

      <!-- Modal footer -->
      <div class="modal-footer">
        <button type="button" class="btn btn-danger" data-dismiss="modal">Close</button>
      </div>

    </div>
  </div>
</div>

{% endblock content %}
